#include "StdAfx.h"
#include "gl/gl.h"
#include "gl/gl.h"
#include "sg.h"

using namespace vcg;

CSG::CSG(void)
{
}

CSG::~CSG(void)
{
}


CSGGroup::~CSGGroup()
{
  iterator i;
	for(i=Sons.begin();i!=Sons.end();++i)
		delete (*i);
}

void CSGGroup::glDraw(const float DocTime)
{
	glPushMatrix();
  iterator i;
	for(i=Sons.begin();i!=Sons.end();++i)
		(*i)->glDraw(DocTime);
	glPopMatrix();
}
void CSGGroup::XMLWrite(FILE *fp)
{
	fprintf(fp,"<CSGGroup >\n");
	iterator i;
	for(i=Sons.begin();i!=Sons.end();++i)
		(*i)->XMLWrite(fp);
	fprintf(fp,"</CSGGroup>\n");
	
}

void CSGTransformation::glDraw(const float DocTime){ glMultMatrix(m); };

void CSGAnimRotation ::glDraw(const float DocTime) 
{
	float CurAngleRad=ToRad(StartAngleDeg + DocTime*AngularSpeedDPS);
	glRotatef( CurAngleRad, axis[0],axis[1],axis[2]);  
};


CSGAnimZPrecession::CSGAnimZPrecession()
{
	StartAngleDeg=0;
	AngularSpeedDPS=10;
	DeclinationDeg=30;
}
 	
void CSGAnimZPrecession::glDraw(const float DocTime) 
{
	// moto di precessione: una rotazione il cui asse ruota intorno all'asse z
	float CurAngleRad=ToRad(StartAngleDeg + DocTime*AngularSpeedDPS);
	glRotated( DeclinationDeg,cos(CurAngleRad),sin(CurAngleRad),0);  
};
	
void CSGAnimZPrecession::XMLWrite(FILE *fp)
{
	fprintf(fp,"<CSGAnimZPrecession\n");
	fprintf(fp,"  DeclinationDeg = \"%f\" AngularSpeedDPS = \"%f\" StartAngleDeg= \"%f\"\n",
		DeclinationDeg,AngularSpeedDPS,StartAngleDeg);
	fprintf(fp,"/>\n");
}
